#include <stdio.h>
#include "k.h"
#include "unpk.h"
#include "printer.h"

void main() {
    funnytree ft;

    /* first, we just call the printer on the example string */
    printer(example_string, base_view);
    printf("\n"); /* we need to print a final newline, due to our unparsing */

    /* separate the previous output from the next */
    printf("\n\n---------------------------\n\n");

    /* build a nice little funyytree, that breaks the printer function */
    ft = Str(mkcasestring("x%y")); /* we should quote % here */
    ft = Cons(ft, ft);
    ft = Cons(ft, ft);

    /* unparse our funnytree, with the printer function that interpretes % */
    unparse_funnytree(ft, printer, base_view);
    printf("\n"); /* we need to print a final newline, due to our unparsing */

    /* separate the previous output from the next */
    printf("\n\n---------------------------\n\n");

    /* unparse our funnytree, with the printer function that does not
     * interpretes %
     */
    unparse_funnytree(ft, debug_printer, base_view);
    printf("\n"); /* we need to print a final newline, due to our unparsing */

    exit(0); /* return a decent value in case of success */
}
